%Runs only on MATLAB version 7 or later (needs to be able to read from Excel
%file, version 6 does not read cell refs.)

clc
clear
close all

%The following commented code generated the .DAT files from the Excel
%spreadsheed Data\FinalDataAll.xls - see spreadsheet for description of
%series

Twts_s                   = xlsread('Data\FinalDataAll.xls','WeightsMat_short','B2:J46'); %Trade weights for short list of 9 countries
Twts_l                   = xlsread('Data\FinalDataAll.xls','WeightsMat_long','B2:M61');  %Trade weights for long list of 12 countries
[dummy, countries_s]     = xlsread('Data\FinalDataAll.xls','Countries_short');           %short list of countries
[dummy, countries_l]     = xlsread('Data\FinalDataAll.xls','Countries_long');            %long list of countries
XRates                   = xlsread('Data\FinalDataAll.xls','XRatesMat','B23:M102'); %Nominal bilateral X-rates (short list of countries,1980-1999Q4)
XRates04                 = xlsread('Data\FinalDataAll.xls','XRatesMat','B23:M120'); %Nominal bilateral X-rates (long list of countries, 1980-2004Q2)
Data                     = xlsread('Data\FinalDataAll.xls','DataMat','CG2:FH241'); %National accounts data (short list of countries,1980-1999Q4)
Data04                   = xlsread('Data\FinalDataAll.xls','DataMat','CG2:FZ241'); %National accounts data (long list of countries, 1980-2004Q2)
CountryID                = xlsread('Data\FinalDataAll.xls','CountryID','A1:A12');  %Country Label ID
CPIall                   = xlsread('Data\FinalDataAll.xls','CPI_AI','B82:M161');   %Consumer Price Index -all items- (short list of countries,1980-1999Q4)
CPIall04                 = xlsread('Data\FinalDataAll.xls','CPI_AI','B82:M179');   %Consumer Price Index -all items- (long list of countries, 1980-2004Q2)
PPI                      = xlsread('Data\FinalDataAll.xls','PPI','B2:M81');        %Producer Price Index (short list of countries,1980-1999Q4)
PPI04                    = xlsread('Data\FinalDataAll.xls','PPI','B2:M99');        %Producer Price Index (long list of countries, 1980-2004Q2)
LC                       = xlsread('Data\FinalDataAll.xls','LC','B2:M81');         %Labor Cost Index (short list of countries,1980-1999Q4)
LC04                     = xlsread('Data\FinalDataAll.xls','LC','B2:M99');         %Labor Cost Index (long list of countries, 1980-2004Q2)
C04                      = xlsread('Data\FinalDataAll.xls','Consumption','B3:M100');         %Consumption data
RLC                      = xlsread('Data\RLC.xls','DATA_RLC','B3:M100');           %Unit Labor Cost Based Real Exchange Rate (data missing for Australia)
REERoecd04               = xlsread('Data\REER04.xls','REER','B3:M100');
NEERIFS04                = xlsread('Data\REER04.xls','NEER','B3:M100');

[dummy, CountriesVLong]  = xlsread('Data\FinalDataAll.xls','Countries_full');
[dummy, Variables]       = xlsread('Data\FinalDataAll.xls','Variables_QNA');

REERoecd04=1.0./REERoecd04*1000;
NEERIFS04 =1.0./NEERIFS04*1000;

TShare=xlsread('Data\FinalDataAll.xls','IntTrade','B42:P56');
Quarters=textread('Data\Quarters.txt','%s');
 
%Load data from CPI files
CPIData=load('Data\CPI_SA.txt'); % cpi data
load Data\CPI_wts.txt; % cpi weights
CPI_lbs=textread('Data\CPI_lbs.txt','%s'); %cpi labels
CPI_lbs=char(CPI_lbs);

Quarters=char(Quarters);
Variables=char(Variables);
countries_s=char(countries_s);
countries_l=char(countries_l);
CountriesVLong=char(CountriesVLong);

Variables=cellstr(Variables);
countries_s=cellstr(countries_s);
countries_l=cellstr(countries_l);
CountriesVLong=cellstr(CountriesVLong);

a=size(Variables);
varnum=a(1);
a=size(countries_s);
counts=a(1);
a=size(countries_l);
countl=a(1);
a=size(Quarters);
time=a(1);
a=size(CountriesVLong);
countmax=a(1);

button=0;
CurrWs=zeros(counts,counts,time);
CurrWl=zeros(countl,countl,time);
counter=0;
multipliers=ones(time+1,counts);
multiplierl=ones(time+1,countl);

dummy=[];
for i=1:countmax
    dummy=Data(1+10*(i-1):10+10*(i-1),:); %reorganize data to match order in countries_l
    dummy=dummy';
    NewData(:,:,i)=dummy;
    dummy=[];
end

dummy=[];
for i=1:countmax
    dummy=Data04(1+10*(i-1):10+10*(i-1),:); %reorganize data to match order in countries_l
    dummy=dummy';
    NewData04(:,:,i)=dummy;
    dummy=[];
end

for i=1:countl %create EPI and IPI series 1980-1999
   EPI(:,i) = NewData(:,3,CountryID(i))./NewData(:,8,CountryID(i)); 
   IPI(:,i) = NewData(:,4,CountryID(i))./NewData(:,9,CountryID(i));     
   Mtplr1=mean(EPI(time-3:time,i));
   Mtplr2=mean(IPI(time-3:time,i)); %normalize the index so that year 2000 = 100
   EPI(:,i)=100*EPI(:,i)/Mtplr1;
   IPI(:,i)=100*IPI(:,i)/Mtplr2;
end

for i=1:countl %create EPI and IPI extended series 1980-2004
   EPI04(:,i) = NewData04(:,3,CountryID(i))./NewData04(:,8,CountryID(i)); 
   IPI04(:,i) = NewData04(:,4,CountryID(i))./NewData04(:,9,CountryID(i));    
   Mtplr1=mean(EPI04(time-3:time,i));
   Mtplr2=mean(IPI04(time-3:time,i)); %normalize the index so that year 2000 = 100
   EPI04(:,i)=100*EPI04(:,i)/Mtplr1;
   IPI04(:,i)=100*IPI04(:,i)/Mtplr2;
end

%load data
CPI_T   = load('Data\CPI_T.txt');  %tradable CPI
CPI_N   = load('Data\CPI_N.txt');  %tradable CPI
CPI_AI  = load('Data\CPI_A.txt');  %CPI all items
OMG     = load('Data\SHARE.txt');  %share of imports in GDP
REERoecd= load('Data\REERoecd_SA.txt'); %trade weighted real effective exchange rate (from SourceOECD)

%extensive country labels (order as in Labels.txt)
country      = {'Belgium';'Canada';'Switzerland';'France';...
                'Germany';'Italy';'Japan';'Netherlands';'US'};  
country_ext  = {'Belgium';'Canada';'Switzerland';'France';...
                'Germany';'Italy';'Japan';'Netherlands';'US';...
                'Australia';'Sweden';'UK'}; 
for i=1:time
    if( Quarters(i,:)=='1985.01' )
        button=1;
        counter=0;
    elseif( Quarters(i,:)=='1990.01' )
        button=2;
        counter=0;
    elseif( Quarters(i,:)=='1995.01' )
        button=3;
        counter=0;
    end
   
    %Here we load all the current weights
    %We take a linear combination with changing weights to get a
    %continuously changing weight
    CurrWs(1:counts,1:counts,i)= (1-counter/20)*Twts_s(1+counts*button:counts+counts*button,1:counts)+...
    (counter/20)*Twts_s(1+counts*(button+1):counts+counts*(button+1),1:counts);
    counter=counter+1;
end
    counter=0;

for i=1:time
    if( Quarters(i,:)=='1985.01' )
        button=1;
        counter=0;
    elseif( Quarters(i,:)=='1990.01' )
        button=2;
        counter=0;
    elseif( Quarters(i,:)=='1995.01' )
        button=3;
        counter=0;
    end
    %Here we load all the current weights
    %We take a linear combination with changing weights to get a
    %continuously changing weight
    CurrWl(1:countl,1:countl,i)= (1-counter/20)*Twts_l(1+countl*button:countl+countl*button,1:countl)+...
    (counter/20)*Twts_l(1+countl*(button+1):countl+countl*(button+1),1:countl);
    counter=counter+1;
end
CurrWl04=ones(countl,countl,98);
CurrWl04(:,:,1:80)=CurrWl;
for i=1:18
    CurrWl04(:,:,80+i)=CurrWl(:,:,80);
end

%______________________________________________________________________
%Construct tradable CPI real exchange rate (using only countries from
%Labels.txt)
CPI=CPI_T; % load tradable CPI
for t=1:time-1
 for i=1:counts
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
    Aux(t,i)=XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t+1) );
    multipliers(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end 
end
t=time;
for i=1:counts
    eCPIs(t,i)=XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
end
rerTcpi=eCPIs./CPI;

%______________________________________________________________________
%Construct all items CPI real exchange rate (using only countries from
%Labels.txt)
CPI=CPIall; % load CPI all items

multipliers=ones(time+1,counts);
for t=1:time-1
 for i=1:counts
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
    Aux(t,i)  =XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t+1) );
    multipliers(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end 
end
t=time;
for i=1:counts
    eCPIs(t,i)=XRates(t,i)*prod( (CPI(t,1:counts)./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
end

rer = eCPIs./CPI(:,1:counts);

%______________________________________________________________________
%Construct nominal effective exchange rate (using 9 countries, short list)
multipliers=ones(time+1,counts);
for t=1:time-1
 for i=1:counts
    %Construct foreign trade weighted NEER
    ner(t,i)=XRates(t,i)*prod( (1./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
    Aux(t,i)=XRates(t,i)*prod( (1./XRates(t,1:counts)).^CurrWs(i,1:counts,t+1) );
    multipliers(t+1,i)=ner(t,i)/Aux(t,i); 
 end 
end
t=time; %last observation manually
for i=1:counts
    ner(t,i)=XRates(t,i)*prod(( 1./XRates(t,1:counts)).^CurrWs(i,1:counts,t) )*multipliers(t,i);
end

%__________________________________________________________________________
%Construct PPI based real exchange rate using extended list of 12
%countries
% - the long list

CPI=PPI;
multiplierl=ones(time+1,countl);

for t=1:time-1
 for i=1:countl
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
    Aux(t,i)  =XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t+1) );
    multiplierl(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end
end
t=time;
for i=1:countl
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
end

REER_PPI= eCPIs./CPI; %use constructed REER (based on 12 countries)

eCPIs=[];
CPI=[];
Aux  =[];

%__________________________________________________________________________
%Construct PPI based real exchange rate using extended list of 12
%countries
% - the long list

CPI=PPI04;
multiplierl=ones(time+1,countl);

for t=1:97
 for i=1:countl
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
    Aux(t,i)  =XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t+1) );
    multiplierl(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end
end
t=98;
for i=1:countl
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
end

REER_PPI04 = eCPIs./CPI; %use constructed REER (based on 12 countries)

%__________________________________________________________________________
%Construct labor cost based real exchange rate using extended list of 12
%countries
% - the long list

% CPI=LC04;
% multiplierl=ones(time+1,countl);
% 
% for t=1:time-1
%  for i=1:countl
%     %Construct foreign trade weighted CPI
%     eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
%     Aux(t,i)  =XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t+1) );
%     multiplierl(t+1,i)=eCPIs(t,i)/Aux(t,i); 
%  end
% end
% t=time;
% for i=1:countl
%     eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
% end
% 
% REER_LC04 = eCPIs./CPI; %use constructed REER (based on 12 countries)

%__________________________________________________________________________
%Construct nominal effective exchange rate using extended list of 12
%countries
% - the long list

CPI=ones(98,12);
multiplierl=ones(time+1,countl);

for t=1:97
 for i=1:countl
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
    Aux(t,i)  =XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t+1) );
    multiplierl(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end
end
t=98;
for i=1:countl
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
end

NEER04 = eCPIs./CPI; %use constructed NEER (based on 12 countries)

%__________________________________________________________________________
%Construct CPI all items real effective exchange rate using extended list
%of 12 countries
% - the long list

CPI=CPIall04;
multiplierl=ones(time+1,countl);

for t=1:97
 for i=1:countl
    %Construct foreign trade weighted CPI
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
    Aux(t,i)  =XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t+1) );
    multiplierl(t+1,i)=eCPIs(t,i)/Aux(t,i); 
 end
end

t=98;
for i=1:countl
    eCPIs(t,i)=XRates04(t,i)*prod( (CPI(t,1:countl)./XRates04(t,1:countl)).^CurrWl04(i,1:countl,t) )*multiplierl(t,i);
end

