%Produces the table with volatility ratio in a cross-section of OECD
%countries

clc
clear
close all

%read data from file
Data               = xlsread('dat.xls','Data');
[dummy,Countries] = xlsread('dat.xls','Countries');
[dummy,Variables] = xlsread('dat.xls','Variables');
ID        = xlsread('dat.xls','CountryID');

%ID variable mapps countries from the data to the order as specified below 
%in the Country array. 
%(each number determines position of country in the rows)
%Repositioned order of the selected countries

for i=1:18
Country(i)=Countries(ID(i));
end 

a=size(Data);
time=a(2);
a=size(Variables);
varnum=a(1);
a=size(Countries);
countnum=a(1);

NewData=zeros(time,varnum,countnum);

dummy=[];

for i=1:countnum 
    dummy=Data(1+10*(i-1):10+10*(i-1),:);
    dummy=dummy';
    NewData(:,:,i)=dummy;
    dummy=[];
end

Omegas=zeros(1,countnum);

nGDP=NewData(:,5,:);
nIm=NewData(:,4,:);

Ratio=nIm./nGDP;

%Clean up
for i=1:countnum
   counter=1;
   dummy=Ratio(1:time,1,i);
   NaNind=isnan(dummy);
   for j=1:time
      if(NaNind(j)==1)
        counter=j+1;
      end 
   end

   Omegas(1,i)=mean(dummy(counter:time));
   dummy=[];
end

Omegas=Omegas';

rGDP=NewData(:,10,:);
rIm =NewData(:,9,:);
rEx =NewData(:,8,:);
nEx =NewData(:,3,:);

%load data to variables
for i=1:countnum
    RatioQ(:,i)=rIm(:,1,i)./(rGDP(:,1,i)-rEx(:,1,i)); %Import ration
    Px(:,i)=nEx(:,1,i)./rEx(:,1,i); %exports deflator price (nominal)
    Pm(:,i)=nIm(:,1,i)./rIm(:,1,i); %import deflator price (nominal)
    Abs_def(:,i)=(nGDP(:,1,i)-nEx(:,1,i))./(rGDP(:,1,i)-rEx(:,1,i)); %domestic absorption deflator price 
    RatioP(:,i)=Abs_def(:,i)./Pm(:,i); %import deflator price 
end

RatioP=log(RatioP);
RatioQ=log(RatioQ);

%Clean up from NaNs
for i=1:countnum
   counter1=1;
   counter2=1;
   dummy2 = RatioP(1:time,i);
   dummy3 = RatioQ(1:time,i);
   NaNind = isnan(dummy2);
   NaNind2= isnan(dummy3);
   dummy2=[];
   dummy3=[];
   
   for j=1:time
      if(NaNind(j)==1)
          counter1=j+1;
      end
      if(NaNind2(j)==1)
          counter2=j+1;
      end
   end

        %HP filter the data
        RatioP_tmp=RatioP(counter1:time,i); 
        RatioQ_tmp=RatioQ(counter2:time,i);
        
        %Linearly detrended!
        dRatioP=RatioP_tmp-hptrend(RatioP_tmp,1600);
        dRatioQ=RatioQ_tmp-hptrend(RatioQ_tmp,1600);
               
        dRatioPlin=RatioP_tmp-hptrend(RatioP_tmp,1000000);
        dRatioQlin=RatioQ_tmp-hptrend(RatioQ_tmp,1000000);
        RatioST(i)=std(dRatioQ)/std(dRatioP);
        RatioSTlin(i)=std(dRatioQlin)/std(dRatioPlin); %linearly detrended
end %country loop 

%Generate Corelogram
%US
   %HP filter the data
        RatioP_tmp=RatioP(counter1:time,14); 
        RatioQ_tmp=RatioQ(counter2:time,14);
        
        dRatioP_US=RatioP_tmp-hptrend(RatioP_tmp,1600);
        dRatioQ_US=RatioQ_tmp-hptrend(RatioQ_tmp,1600);

        for k=0:20; matcc=Corrcoef(dRatioQ_US(1+k:60+k),dRatioP_US(1:60)); corrUS(k+1)=matcc(2,1); end
            
        figure(1);plot(corrUS)
%Japan
   %HP filter the data
        RatioP_tmp=RatioP(counter1:time,10); 
        RatioQ_tmp=RatioQ(counter2:time,10);
        
        dRatioP_JAP=RatioP_tmp-hptrend(RatioP_tmp,1600);
        dRatioQ_JAP=RatioQ_tmp-hptrend(RatioQ_tmp,1600);

                for k=0:20; matcc=Corrcoef(dRatioQ_JAP(1+k:60+k),dRatioP_JAP(1:60)); corrJAP(k+1)=matcc(2,1); end
                            figure(2);plot(corrJAP)
                  
%UK
   %HP filter the data
        RatioP_tmp=RatioP(counter1:time,13); 
        RatioQ_tmp=RatioQ(counter2:time,13);
        
        dRatioP_UK=RatioP_tmp-hptrend(RatioP_tmp,1600);
        dRatioQ_UK=RatioQ_tmp-hptrend(RatioQ_tmp,1600);

        for k=0:20; matcc=Corrcoef(dRatioQ_UK(1+k:60+k),dRatioP_UK(1:60)); corrUK(k+1)=matcc(2,1); end    
        figure(3);plot(corrUK)
        
%GERMANY
   %HP filter the data
        RatioP_tmp=RatioP(counter1:time,8); 
        RatioQ_tmp=RatioQ(counter2:time,8);
        
        dRatioP_GER=RatioP_tmp-hptrend(RatioP_tmp,1600);
        dRatioQ_GER=RatioQ_tmp-hptrend(RatioQ_tmp,1600);

        for k=0:20; matcc=Corrcoef(dRatioQ_GER(1+k:60+k),dRatioP_GER(1:60)); corrGER(k+1)=matcc(2,1); end
            
        figure(4);plot(corrGER)
       
CID(1)=1; CID(2)=3; CID(3)=6; CID(4)=7; CID(5)=8; CID(6)=9; CID(7)=10; CID(8)=11; CID(9)=12; CID(10)=13;
CID(11)=14; CID(12)=15; CID(13)=20; CID(14)=22; CID(15)=24;

for i=1:16
 counter1=1;
   counter2=1;
   dummy2 = RatioP(1:time,i);
   dummy3 = RatioQ(1:time,i);
   NaNind = isnan(dummy2);
   NaNind2= isnan(dummy3);
   dummy2=[];
   dummy3=[];
   
   for j=1:time
      if(NaNind(j)==1)
          counter1=j+1;
      end
      if(NaNind2(j)==1)
          counter2=j+1;
      end
   end
    
RatioP_tmp=RatioP(counter1:time,ID(i)); 
RatioQ_tmp=RatioQ(counter2:time,ID(i));
dRatioP=RatioP_tmp-hptrend(RatioP_tmp,1600);
dRatioQ=RatioQ_tmp-hptrend(RatioQ_tmp,1600);

ss=size(dRatioP)
for k=0:20; matcc=Corrcoef(dRatioQ(1+k:ss(1)-20+k),dRatioP(1:ss(1)-20)); corrALL(k+1,i)=matcc(2,1); end
end

%Countries as they apear in 16 country vector less Denmark and Portugal

fid1 = fopen('Data_corr.txt','w');

fprintf(fid1,'%6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f %6.6f\n',... 
[corrALL(:,1)';corrALL(:,2)';corrALL(:,3)';corrALL(:,4)';corrALL(:,5)'; ...
 corrALL(:,6)';corrALL(:,7)';corrALL(:,8)';corrALL(:,9)';corrALL(:,10)';...
 corrALL(:,11)';corrALL(:,12)';corrALL(:,14)';corrALL(:,15)']);

fclose(fid1)
                
%Restrict attention to 14 countries repositioned 
%as in ID specification (previous 12 + Denmark and Finland)
for i=1:18
    ST(i)=RatioST(ID(i));
    STlin(i)=RatioSTlin(ID(i));
    Om(i)=Omegas(ID(i)); %imports to GDP (share of trade to GDP)
end 
hist(ST(1:16),8)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
title('Volatility Ratio in a Cross-Section of OECD Countries','FontSize',9)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%TABLE 2. Correlation and volatility tradable CPI real exchange rate and
%CPI all items real exchange rate
%TEMPLATE A
%
file ={'Table.txt'};
title={'Volatility Ratio in a Cross-Section of OECD Countries$^{a}$'};
label={'Table'};
small=[];
chead=[0 1 2; 1 1 1];
hrow ={'Detrending method','Country','HP-1600','Linear$^{b}$'};
Country(9)=cellstr([char(Country(9)) '$^{c}$']);
data(1:16,1:2)=[ST(1:16)' STlin(1:16)'];

fcol = Country(1:16); hline=[]; 
csin=[3.0;1.1;1.1];
dec =[2;2];
opt=[1 0 0];
fnote= {'$^{a}$Based on quarterly series, 1980:1-2000:1. Volatility ratio is the standard deviation of the \textit{product mix ratio} divided by to the standard deviation of the \textit{price ratio}. \textit{Product mix ratio} is country''s imports (IM) divided by the domestic absorption (C+I+G-IM) measured in constant prices. \textit{Price ratio} is the deflator price of domestic absorption divided by the deflator price of imports. Data sources listed in the Appendix. \newline $^{b}$Linear trend subtracted from the logged series. \newline $^{c}$For the entire post-war period (1959:3-2004:2) this ratio in US is 0.88.'};
TabTeX(file,title,label,chead,hrow,fcol,hline,csin,dec,data,fnote,opt,small); 

PrevTeX({'Table.txt'});

fid=fopen('SHARE.txt','w');
fprintf(fid,'%.2f\n',Om(1:12));
fclose(fid);